'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMoleculeDropdownList = require('@s-ui/react-molecule-dropdown-list');

var _reactMoleculeDropdownList2 = _interopRequireDefault(_reactMoleculeDropdownList);

var _reactMoleculeInputTags = require('@s-ui/react-molecule-input-tags');

var _reactMoleculeInputTags2 = _interopRequireDefault(_reactMoleculeInputTags);

var _withSelectUi = require('../hoc/withSelectUi');

var _withSelectUi2 = _interopRequireDefault(_withSelectUi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MoleculeInputSelect = (0, _withSelectUi2.default)(_reactMoleculeInputTags2.default);

var MoleculeSelectFieldMultiSelection = function MoleculeSelectFieldMultiSelection(props) {
  /* eslint-disable react/prop-types */
  var children = props.children,
      isOpen = props.isOpen,
      onToggle = props.onToggle,
      onChange = props.onChange,
      iconArrowDown = props.iconArrowDown,
      iconCloseTag = props.iconCloseTag,
      refMoleculeSelect = props.refMoleculeSelect,
      values = props.value,
      placeholder = props.placeholder,
      keysSelection = props.keysSelection;


  var handleMultiSelection = function handleMultiSelection(ev, _ref) {
    var valueOptionSelected = _ref.value;

    var newValues = values.includes(valueOptionSelected) ? values.filter(function (value) {
      return value !== valueOptionSelected;
    }) : [].concat((0, _toConsumableArray3.default)(values), [valueOptionSelected]);
    var key = ev.key;

    var isKeySelection = keysSelection.includes(key);
    onChange(ev, { value: newValues });
    if (ev.key !== undefined && !isKeySelection) onToggle(ev, { isOpen: false });
  };

  var handleChangeTags = function handleChangeTags(ev, _ref2) {
    var value = _ref2.tags;

    onChange(ev, { value: value });
    refMoleculeSelect.current.focus();
  };

  return _react2.default.createElement(
    _react.Fragment,
    null,
    _react2.default.createElement(MoleculeInputSelect, {
      tags: values,
      onClick: onToggle,
      tagsCloseIcon: iconCloseTag,
      iconArrowDown: iconArrowDown,
      onChangeTags: handleChangeTags,
      isOpen: isOpen,
      placeholder: !values.length ? placeholder : '',
      noBorder: true
    }),
    _react2.default.createElement(
      _reactMoleculeDropdownList2.default,
      {
        checkbox: true,
        visible: isOpen,
        onSelect: handleMultiSelection,
        value: values
      },
      children
    )
  );
};

MoleculeSelectFieldMultiSelection.displayName = 'MoleculeSelectFieldMultiSelection';

MoleculeSelectFieldMultiSelection.defaultProps = {
  value: []
};

exports.default = MoleculeSelectFieldMultiSelection;